Bug 519517 - [RHEL5 gcc44-c++] Code with virtual inheritance compiled by g++ crash at run-time
Summary: [RHEL5 gcc44-c++] Code with virtual inheritance compiled by g++ crash at run-...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: gcc44
Version: 5.4
Hardware: All
OS: Linux
high
high
Target Milestone: rc
: ---
Assignee: Jakub Jelinek
QA Contact:
URL:
Whiteboard:
Depends On:
Blocks: 499522
TreeView+ depends on / blocked
 
Reported: 2009-08-26 22:07 UTC by Jeff Bastian
Modified: 2018-11-14 19:57 UTC (History)
2 users (show)

Fixed In Version: gcc44-4.4.4-13.el5
Doc Type: Bug Fix
Doc Text:
Clone Of:
: 519519 (view as bug list)
Environment:
Last Closed: 2011-01-14 00:00:18 UTC


Attachments (Terms of Use)
reproducer program (1.67 KB, text/plain)
2009-08-26 22:07 UTC, Jeff Bastian
no flags Details
proposed patch (5.53 KB, patch)
2009-08-27 20:34 UTC, Jeff Bastian
no flags Details | Diff


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHBA-2011:0102 normal SHIPPED_LIVE gcc44 bug fix update 2011-01-12 17:21:10 UTC

Description Jeff Bastian 2009-08-26 22:07:18 UTC
Created attachment 358780 [details]
reproducer program

Description of problem:
The attached program when compiled by g++ will crash at runtime.  It runs fine when compiled with Sun Studio CC and AIX xlC on their respective platforms.  This was reported upstream and a patch has been accepted.
  http://gcc.gnu.org/ml/gcc-patches/2009-07/msg00302.html
  http://gcc.gnu.org/viewcvs?revision=149297&view=revision

Please include this patch in the gcc44-c++ compilers for RHEL 5.

Version-Release number of selected component (if applicable):
gcc44-c++-4.4.0-6.el5

How reproducible:
every time

Steps to Reproduce:
1. g++44 dyncast-segfault.cpp
2. ./a.out
  
Actual results:
...
in synchro_slave_base dtor
in my_object dtor
before DCASTing to my_module*
Segmentation fault


Expected results:
no seg fault

Additional info:

Comment 1 Jeff Bastian 2009-08-27 20:34:53 UTC
Created attachment 358964 [details]
proposed patch

The upstream patch applies cleanly to gcc44-4.4.0-6.el5 except for the ChangeLog updates.  Attached is a patch minus the ChangeLog chunks.

Comment 3 Jakub Jelinek 2009-09-03 09:00:55 UTC
The patch is now in rawhide gcc.

Comment 14 errata-xmlrpc 2011-01-14 00:00:18 UTC
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2011-0102.html


Note You need to log in before you can comment on or make changes to this bug.